mod Ex09a logic: 'cl'

incl Mtex

incl Mtexg

incl Mtexnt

incl Mauxa

loc rem 
  \para \bf  9. CVIČENIE Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21 
  \para* \it  Dátum:  \end streda 26.4.2017 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/1617ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované týmto 
  témam: 
  \items 
   \item \para symbolické výrazy, 
   \item \para primitívne rekurzívne funkcie. 
  \end
  \para Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  maux*.cl  \end obsahujú definície a vlastnosti 
         pomocných funkcií a predikátov. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbory \it  mlogic*.cl  \end obsahujú popis verifikačnej 
         časti systému CL. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 2 
   \item \para Počet bodov za prémiove úlohy v tomto súbore:: 2 
  \end
  \para Odovzdať do 9.5.2017 (utorok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Specification and Verification of 
         Programs. Online. 
   \item \para \it  [2]  \end Ján Kľuka. Úvod do deklaratívneho 
         programovania. Online. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Symbolic Expressions.  \end 

rem 
  \para \bf  Section. Numeric Terms.  \end 

rem 
  \para \bf  Subsection. Arithmetization of Numeric Terms.  \end 

rem 
  \para \bf  Constructors of numeric terms.  \end 

fun Vt 'Tex_f1_nt_vt'
  Vt(i) = 0,i

fun Ct 'Tex_f1_nt_ct'
  Ct(n) = 1,n

fun/2 At 'Tex_f2_nt_at'
  At(t1,t2) = 2,t1,t2

fun/2 Mt 'Tex_f2_nt_mt'
  Mt(t1,t2) = 3,t1,t2

rem 
  \para \bf  [CL] Discrimination on the constructors of numeric terms.  \end 
  Example(s): 
  \def 
    fun F 'Tex_f1_f'
    F Vt(i) = Foo
    F Ct(n) = Foo
    F At(t1,t2) = Foo
    F Mt(t1,t2) = Foo
  \end

rem 
  \para \bf  Numeric terms.  \end 

pred Term 
  Term Vt(i) <- N(i)
  Term Ct(n) <- N(n)
  Term At(t1,t2) <- Term(t1) & Term(t2)
  Term Mt(t1,t2) <- Term(t1) & Term(t2)

rem 
  \para \bf  [CL] Formatting the output.  \end Use the format \ft Term \end to 
  display numbers as numeric terms. Try out the following simple queries 
  \verbatim 
     98041654 = t:Term
  \end
  \verbatim 
     3,(2,(0,1),1,2),0,3 = t:Term
  \end

rem 
  \para \bf  [CL] Structural case analysis on numeric terms.  \end Syntax: 
  \eq* 
    'case Term ; <term>'
  \end
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_case Tex_f2_g_x_sc(Term,t) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f1_g_x_assum Term(t),
                            Tex_f2_g_x_branch(Tex_f1_g_x_assum Tex_f2_g_eq(t,
                                                                           Vt(i)),
                                              Tex_f2_g_x_branch(Tex_f1_g_x_assum Tex_f2_g_eq(t,
                                                                                             Ct(n)),
                                                                Tex_f2_g_x_branch(Tex_f1_g_x_assum Tex_f2_g_and(Tex_f2_g_eq(t,
                                                                                                                            At(t1,
                                                                                                                               t2)),
                                                                                                                Tex_f2_g_and(Term(t1),
                                                                                                                             Term(t2))),
                                                                                  Tex_f1_g_x_assum Tex_f2_g_and(Tex_f2_g_eq(t,
                                                                                                                            Mt(t1,
                                                                                                                               t2)),
                                                                                                                Tex_f2_g_and(Term(t1),
                                                                                                                             Term(t2)))))))
         \end
         \para where \ft i \end, \ft n \end, \ft t1 \end and \ft t2 \end are new 
         variables \it  (eigen-variables)  \end. 
  \end

rem 
  \para \bf  Structural induction on numeric terms. \it  (1 point)  \end  \end 
  Show that the principle of structural induction over numeric terms is 
  admissible in Peano arithmetic. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 
  \para \it  [CL] Hint.  \end Reduce structural induction on \ft t \end to 
  course of values induction with measure \ft |t| \end. Recall that the pair 
  size function \ft |x| \end, written as \it  |x|  \end, is defined in the 
  module \it  Standard  \end. 

theory Structural_induction_on_numeric_terms

pred A 'Tex1_g_appl_phi_sb'

axiom Base_case_vt
  A Vt(i)

axiom Base_case_ct
  A Ct(n)

axiom Induction_step_at
  A(t1) & A(t2) -> A At(t1,t2)

axiom Induction_step_mt
  A(t1) & A(t2) -> A Mt(t1,t2)

thm Conclusion
  Term(t) -> A(t)

end theory Structural_induction_on_numeric_terms

rem 
  \para \bf  [CL] Structural induction on numeric terms.  \end 
  \header* fun R 'Tex1_g_appl_phi_sb' \end Syntax: 
  \eq* 
    'ind Term ; <variable> [; <variable(s)>]'
  \end
  \para where the induction formula is formed from the current sequent. 
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_ind Tex_f2_g_x_sc(Term,t) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f1_g_x_goal Tex_f2_g_imp(Term(t),R(t)),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal R Vt(i),
                                              Tex_f2_g_x_branch(Tex_f1_g_x_goal R Ct(n),
                                                                Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and(R(t1),
                                                                                                                            R(t2)),
                                                                                                               R At(t1,
                                                                                                                    t2)),
                                                                                  Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and(R(t1),
                                                                                                                            R(t2)),
                                                                                                               R Mt(t1,
                                                                                                                    t2))))))
         \end
         \para where \ft i \end, \ft n \end, \ft t1 \end and \ft t2 \end are new 
         variables \it  (eigen-variables)  \end. 
   \item \para \ft Tex_f1_g_x_ind Tex_f2_g_x_sc(Tex_f2_g_x_sc(Term,t),a) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f1_g_x_goal Tex_f2_g_imp(Term(t),R(t)),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal R Vt(i),
                                              Tex_f2_g_x_branch(Tex_f1_g_x_goal R Ct(n),
                                                                Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and(Tex_f2_g_forall(a,
                                                                                                                                            R(t1)),
                                                                                                                            Tex_f2_g_forall(a,
                                                                                                                                            R(t2))),
                                                                                                               R At(t1,
                                                                                                                    t2)),
                                                                                  Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and(Tex_f2_g_forall(a,
                                                                                                                                            R(t1)),
                                                                                                                            Tex_f2_g_forall(a,
                                                                                                                                            R(t2))),
                                                                                                               R Mt(t1,
                                                                                                                    t2))))))
         \end
         \para where \ft i \end, \ft n \end, \ft t1 \end and \ft t2 \end are new 
         variables \it  (eigen-variables)  \end. 
  \end

rem 
  \para \bf  [CL] Structural induction on numeric terms (2nd form).  \end 
  \header* fun R 'Tex1_g_appl_phi_sb' \end Syntax: 
  \eq* 
    'ind* Term ; <variable> [; <variable(s)>]'
  \end
  \para where the induction formula is formed from the current sequent. 
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_inds Tex_f2_g_x_sc(Term,t) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f1_g_x_goal Tex_f2_g_imp(Term(t),R(t)),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal R Vt(i),
                                              Tex_f2_g_x_branch(Tex_f1_g_x_goal R Ct(n),
                                                                Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and3(Tex_f2_g_and3(Term(t1),
                                                                                                                                           R(t1)),
                                                                                                                             Tex_f2_g_and3(Term(t2),
                                                                                                                                           R(t2))),
                                                                                                               R At(t1,
                                                                                                                    t2)),
                                                                                  Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and3(Tex_f2_g_and3(Term(t1),
                                                                                                                                           R(t1)),
                                                                                                                             Tex_f2_g_and3(Term(t2),
                                                                                                                                           R(t2))),
                                                                                                               R Mt(t1,
                                                                                                                    t2))))))
         \end
         \para where \ft i \end, \ft n \end, \ft t1 \end and \ft t2 \end are new 
         variables \it  (eigen-variables)  \end. 
   \item \para \ft Tex_f1_g_x_inds Tex_f2_g_x_sc(Tex_f2_g_x_sc(Term,t),a) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f1_g_x_goal Tex_f2_g_imp(Term(t),R(t)),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal R Vt(i),
                                              Tex_f2_g_x_branch(Tex_f1_g_x_goal R Ct(n),
                                                                Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and3(Tex_f2_g_and3(Term(t1),
                                                                                                                                           Tex_f2_g_forall(a,
                                                                                                                                                           R(t1))),
                                                                                                                             Tex_f2_g_and3(Term(t2),
                                                                                                                                           Tex_f2_g_forall(a,
                                                                                                                                                           R(t2)))),
                                                                                                               R At(t1,
                                                                                                                    t2)),
                                                                                  Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and3(Tex_f2_g_and3(Term(t1),
                                                                                                                                           Tex_f2_g_forall(a,
                                                                                                                                                           R(t1))),
                                                                                                                             Tex_f2_g_and3(Term(t2),
                                                                                                                                           Tex_f2_g_forall(a,
                                                                                                                                                           R(t2)))),
                                                                                                               R Mt(t1,
                                                                                                                    t2))))))
         \end
         \para where \ft i \end, \ft n \end, \ft t1 \end and \ft t2 \end are new 
         variables \it  (eigen-variables)  \end. 
  \end

rem 
  \para \bf  Subsection. Basic Operations and Predicates.  \end 

rem 
  \para \bf  Denotation of numeric terms.  \end 

fun/2 Den 'Tex_f2_nt_den'
  Den(Vt(i),v) = Sub(v,i)
  Den(Ct(n),v) = n
  Den(At(t1,t2),v) = Den(t1,v)+Den(t2,v)
  Den(Mt(t1,t2),v) = Den(t1,v)*Den(t2,v)

rem 
  \para \bf  Subsection. Postfix Machine.  \end 

rem 
  \para \bf  Instructions.  \end 

fun Vi 'Tex_f1_nt_vi'
  Vi(i) = 0,i

fun Ci 'Tex_f1_nt_ci'
  Ci(n) = 1,n

fun/0 Ai 'Tex_f0_nt_ai'
  Ai = 2,0

fun/0 Mi 'Tex_f0_nt_mi'
  Mi = 3,0

pred Instr 
  Instr Vi(i) <- N(i)
  Instr Ci(n) <- N(n)
  Instr(Ai)
  Instr(Mi)

rem 
  \para \bf  Programs.  \end 

pred Program 
  Program(0)
  Program(i,p) <- Instr(i) & Program(p)

rem 
  \para \bf  Compilation.  \end 

fun Cmp 
  Cmp(t) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Term(t) -> Program Cmp(t)
  \end

thm Cmp_program
  Term(t) -> Program Cmp(t)
proof  proved.

rem 
  \para \bf  One-step evaluation.  \end 

fun/3 Run 
  Run(t,v,s) = Foo

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end Prove 
  \eq* 
    Term(t) -> Den(t,v) = Run(Cmp(t),v,0)
  \end

thm Den_run
  Term(t) -> Den(t,v) = Run(Cmp(t),v,0)

rem 
  \para \bf  Decompilation. \it  (bonus 2 points)  \end  \end Define the 
  function \ft Decmp(t) \end such that 
  \eq* 
    Term(t) -> Decmp Cmp(t) = t
  \end
  \para Verify your implementation! 
  \para \it  Hint.  \end \header* fun/2 Decmp1 'Tex_f2_f' \end Define first an 
  auxiliary binary function \ft Decmp1(p,s) \end such that 
  \eq* 
    Term(t) -> Decmp1(Cmp(t)++p,s) = Decmp1(p,t,s)
  \end

fun/2 Decmp1 'Tex_f2_f'
  Decmp1(p,s) = Foo

fun Decmp 
  Decmp(p) = Foo

thm Invariant_decmp1
  Term(t) -> Decmp1(Cmp(t)++p,s) = Decmp1(p,t,s)
proof  proved.

thm Decmp_cmp
  Term(t) -> Decmp Cmp(t) = t

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun/0 T1 
  T1 = Mt(At(Vt(1),Ct(2)),Vt(3))

loc rem 
  Useful queries:
  T1 = t:Term & 0,11,0,13,0 = v & Den(t,v) = a
  T1 = t:Term & 0,11,0,13,0 = v & Run(Cmp(t),v,0) = a
  T1 = t1:Term & Decmp Cmp(t1) = t2:Term

