mod Ex01b

incl Mtex

incl Mtexrc

incl Mauxb

loc rem 
  \para \bf  9. CVIČENIE Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21 
  \para* \it  Dátum:  \end streda 26.4.2017 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/1617ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované týmto 
  témam: 
  \items 
   \item \para symbolické výrazy, 
   \item \para primitívne rekurzívne funkcie. 
  \end
  \para Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  maux*.cl  \end obsahujú definície a vlastnosti 
         pomocných funkcií a predikátov. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbory \it  mlogic*.cl  \end obsahujú popis verifikačnej 
         časti systému CL. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 2 
   \item \para Počet bodov za prémiove úlohy v tomto súbore:: 3 
  \end
  \para Odovzdať do 9.5.2017 (utorok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Specification and Verification of 
         Programs. Online. 
   \item \para \it  [2]  \end Ján Kľuka. Úvod do deklaratívneho 
         programovania. Online. 
  \end

rem 
  \para \bf  Remark.  \end The abbreviation \it  p.r.  \end stands for \it  
  primitive recursive.  \end 

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Basic primitive recursive functions.  \end See also the module \it  
  Maux*  \end. 

rem 
  \para \bf  Composition.  \end 

rem 
  \para \bf  Primitive recursion.  \end 

rem 
  \para \bf  Primitive recursive functions.  \end 

rem 
  \para \bf  Example.  \end Find a p.r. derivation of the ternary function 
  \eq* 
    Tex_f3_h(x,z,y) = z+1
  \end

fun/3 H_plus 'Tex_f3_h'
  H_plus(x,z,y) = Foo

rem 
  \para \bf  Addition is primitive recursive. \it  (1 point)  \end  \end Find a 
  p.r. derivation of the addition function \ft x+y \end. 
  \para \it  Hint.  \end Note that 
  \eq* 
    0+y = y
  \end
  \eq* 
    x+1+y = x+y+1
  \end

fun/2 Plus 'Tex_f2_n_plus'
  Plus(x,y) = Foo

rem 
  \para \bf  Subsection. Exercises.  \end 

rem 
  \para \bf  Exercise.  \end Find a p.r. derivation of the multiplication 
  function \ft x*y \end. 
  \para \it  Hint.  \end Note that 
  \eq* 
    0*y = 0
  \end
  \eq* 
    (x+1)*y = x*y+y
  \end

fun/2 Times 'Tex_f2_n_times'
  Times(x,y) = Foo

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end Find a p.r. derivation of the 
  exponentiation function \ft Tex_f2_n_exp(x,y) \end. 
  \para \it  Hint.  \end Recall that 
  \eq* 
    Tex_f2_n_exp(x,0) = 1
  \end
  \eq* 
    Tex_f2_n_exp(x,y+1) = x*Tex_f2_n_exp(x,y)
  \end
  \para Rewrite the recurrences for the binary function 
  \eq* 
    Tex_f2_f(y,x) = Tex_f2_n_exp(x,y)
  \end

fun/2 Exp1 'Tex_f2_f'
  Exp1(y,x) = Foo

fun/2 Exp 'Tex_f2_n_exp'
  Exp(x,y) = Foo

rem 
  \para \bf  Subsection. Additional Problems.  \end 

rem 
  \para \bf  Exercise. \it  (1 bonus point)  \end  \end Find a 'short' p.r. 
  derivation of the constant function 
  \eq* 
    C256(x) = 256
  \end

fun C256 
  C256(x) = Foo

rem 
  \para \bf  Exercise.  \end Find a p.r. derivation of the predecessor function 
  \ft x-1 \end. 
  \para \it  Hint.  \end Note that 
  \eq* 
    0-1 = 0
  \end
  \eq* 
    x+1-1 = x
  \end
  \para Rewrite the recurrences for the binary function 
  \eq* 
    Tex_f2_f(x,y) = x-1
  \end
  \para with the dummy second argument. 

fun/2 Pred1 'Tex_f2_f'
  Pred1(x,y) = Foo

fun Pred 'Tex_f1_rec_pred'
  Pred(x) = Foo

rem 
  \para \bf  Exercise. \it  (bonus 2 points)  \end  \end Find a p.r. derivation 
  of the modified subtraction function \ft x-y \end. 
  \para \it  Hint.  \end Note that 
  \eq* 
    x-0 = x
  \end
  \eq* 
    x-(y+1) = x-y-1
  \end
  \para Rewrite the recurrences for the binary function 
  \eq* 
    Tex_f2_f(y,x) = x-y
  \end

fun/2 Minus1 'Tex_f2_f'
  Minus1(y,x) = Foo

fun/2 Minus 'Tex_f2_n_minus'
  Minus(x,y) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

